--- old/usr/src/uts/common/fs/zfs/dmu.c	2014-10-28 11:57:19.082610739 -0700
+++ new/usr/src/uts/common/fs/zfs/dmu.c	2014-10-28 11:57:19.086643881 -0700
@@ -810,6 +810,28 @@
 }
 
 void
+dmu_write_zero(objset_t *os, uint64_t object, uint64_t offset, uint64_t size, dmu_tx_t *tx)
+{
+	dmu_buf_t	**dbp;
+	int		numbufs, i;
+
+	VERIFY(0 == dmu_buf_hold_array(os, object, offset, size,
+	    FALSE, FTAG, &numbufs, &dbp));
+
+	for (i = 0; i < numbufs; i++) {
+		dmu_buf_t *db = dbp[i];
+
+		dmu_buf_will_zero_fill(db, tx);
+
+		memset(db->db_data, 0, db->db_size);
+
+		dmu_buf_fill_done(db, tx);
+	}
+
+	dmu_buf_rele_array(dbp, numbufs, FTAG);
+}
+
+void
 dmu_write(objset_t *os, uint64_t object, uint64_t offset, uint64_t size,
     const void *buf, dmu_tx_t *tx)
 {
@@ -1796,6 +1818,7 @@
 	zp->zp_dedup = dedup;
 	zp->zp_dedup_verify = dedup && dedup_verify;
 	zp->zp_nopwrite = nopwrite;
+	zp->zp_zero_write = B_FALSE;
 }
 
 int
